#ifndef AVIC_USB_HPP_INCLUDED
#define AVIC_USB_HPP_INCLUDED

#include <windows.h>

#define AVIC_HID_DEVICE __declspec(dllexport)

// Return Codes
#define HID_DEVICE_SUCCESS					0x00
#define HID_DEVICE_NOT_FOUND				0x01
#define HID_DEVICE_ALREADY_OPENED			0x03
#define HID_DEVICE_HIGH_VOLTAGE_BLOCK_OUT	0x0B

#define MAX_PATH_LENGTH					MAX_PATH

//settings
#define flgSpeedIndex		0x7 << 0
#define flgAutoOffVoltage	1 << 3
#define flgDirrectCurr		1 << 4
#define flgStartAutoMode	1 << 6

//condition
#define DoorIsOpen		1 << 0
#define HightVolt		1 << 1
#define AutoMode		1 << 2
#define MinLATRSensor	1 << 3
#define SignVolt		1 << 4
#define HVCommutator	1 << 5
#define HVBlockOut		1 << 6

struct STRING_AVIC {
	COORD pos;
	LPCSTR text;
};

struct METERAGE { //      
	BYTE settings;	//   
	BYTE limitVoltAC;		//   , 1 . = 1 
	BYTE limitCurrentAC;	//   , 1 . = 1 
	BYTE limitVoltDC;		//   , 1 . = 1 
	BYTE limitCurrentDC;	//   , 1 . = 1 
	BYTE timeSec;	// , 
	BYTE timeMin;	// , 
	BYTE timeHour;	// , 
	short int currentAverageFlt;	//    ,    , 1 . = 0,01 
	short int voltageAverageFlt;	//   ,    , 1 . = 0,01 
	short int voltageFlt;	//   ,    , 1 . = 0,01 
	short int currentFlt;	//    ,    , 1 . = 0,01 
	short int voltageAmplitudeFlt;	//  ,    , 1 . = 0,01 
	char voltage[2];	//    , 1 . = 0,01 
//	voltage = (voltage[1] + voltage[0] * 256)
	char current[2];	//     , 1 . = 0,01 
//	current = (current[1] + current[0] * 256)
	char defineVolt[2];	//  , 1 . = 0,01 
//	defineVolt = (defineVolt[1] + defineVolt[0] * 256)
	char stepsLATR;		//    
	BYTE condition;		//  
};

extern "C" {

AVIC_HID_DEVICE BYTE AVIC_FindDevice();
AVIC_HID_DEVICE BYTE AVIC_GetManufacturerString(char* szManufacturerString, unsigned long sizeString);
AVIC_HID_DEVICE BYTE AVIC_GetDeviceString(char* szBuffer, unsigned long sizeString);
AVIC_HID_DEVICE BYTE AVIC_ReadMeterage(METERAGE* meterage);

}

#endif // AVIC_USB_HPP_INCLUDED
